



<!doctype html>
<html lang="en" class="no-js">
  <head>
    
      <meta charset="utf-8">
      <meta name="viewport" content="width=device-width,initial-scale=1">
      <meta http-equiv="x-ua-compatible" content="ie=edge">
      
        <meta name="description" content="Network API, manipulate your network infrastructure as code">
      
      
        <link rel="canonical" href="https://davidban77.gitlab.io/netapi/api/api_net_reference/">
      
      
        <meta name="author" content="David Flores">
      
      
        <meta name="lang:clipboard.copy" content="Copy to clipboard">
      
        <meta name="lang:clipboard.copied" content="Copied to clipboard">
      
        <meta name="lang:search.language" content="en">
      
        <meta name="lang:search.pipeline.stopwords" content="True">
      
        <meta name="lang:search.pipeline.trimmer" content="True">
      
        <meta name="lang:search.result.none" content="No matching documents">
      
        <meta name="lang:search.result.one" content="1 matching document">
      
        <meta name="lang:search.result.other" content="# matching documents">
      
        <meta name="lang:search.tokenizer" content="[\s\-]+">
      
      <link rel="shortcut icon" href="../../assets/images/favicon.png">
      <meta name="generator" content="mkdocs-1.0.4, mkdocs-material-4.4.3">
    
    
      
        <title>Builders and Net Objects - NetAPI</title>
      
    
    
      <link rel="stylesheet" href="../../assets/stylesheets/application.30686662.css">
      
        <link rel="stylesheet" href="../../assets/stylesheets/application-palette.a8b3c06d.css">
      
      
        
        
        <meta name="theme-color" content="#009688">
      
    
    
      <script src="../../assets/javascripts/modernizr.74668098.js"></script>
    
    
      
        <link href="https://fonts.gstatic.com" rel="preconnect" crossorigin>
        <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Roboto:300,400,400i,700|Roboto+Mono&display=fallback">
        <style>body,input{font-family:"Roboto","Helvetica Neue",Helvetica,Arial,sans-serif}code,kbd,pre{font-family:"Roboto Mono","Courier New",Courier,monospace}</style>
      
    
    <link rel="stylesheet" href="../../assets/fonts/material-icons.css">
    
    
    
      
    
    
  </head>
  
    
    
    <body dir="ltr" data-md-color-primary="teal" data-md-color-accent="teal">
  
    <svg class="md-svg">
      <defs>
        
        
          <svg xmlns="http://www.w3.org/2000/svg" width="500" height="500" viewBox="0 0 500 500" id="__gitlab"><path fill="currentColor" d="M93.667 473.347l90.684-279.097H2.983l90.684 279.097z" transform="translate(156.198 1.16)"/><path fill="currentColor" d="M221.333 473.345L130.649 194.25H3.557l217.776 279.095z" transform="translate(28.531 1.16)" opacity=".7"/><path fill="currentColor" d="M32 195.155L4.441 279.97a18.773 18.773 0 0 0 6.821 20.99l238.514 173.29L32 195.155z" transform="translate(.089 .256)" opacity=".5"/><path fill="currentColor" d="M2.667-84.844h127.092L75.14-252.942c-2.811-8.649-15.047-8.649-17.856 0L2.667-84.844z" transform="translate(29.422 280.256)"/><path fill="currentColor" d="M2.667 473.345L93.351 194.25h127.092L2.667 473.345z" transform="translate(247.198 1.16)" opacity=".7"/><path fill="currentColor" d="M221.334 195.155l27.559 84.815a18.772 18.772 0 0 1-6.821 20.99L3.557 474.25l217.777-279.095z" transform="translate(246.307 .256)" opacity=".5"/><path fill="currentColor" d="M130.667-84.844H3.575l54.618-168.098c2.811-8.649 15.047-8.649 17.856 0l54.618 168.098z" transform="translate(336.974 280.256)"/></svg>
        
      </defs>
    </svg>
    <input class="md-toggle" data-md-toggle="drawer" type="checkbox" id="__drawer" autocomplete="off">
    <input class="md-toggle" data-md-toggle="search" type="checkbox" id="__search" autocomplete="off">
    <label class="md-overlay" data-md-component="overlay" for="__drawer"></label>
    
      <a href="#__init__" tabindex="1" class="md-skip">
        Skip to content
      </a>
    
    
      <header class="md-header" data-md-component="header">
  <nav class="md-header-nav md-grid">
    <div class="md-flex">
      <div class="md-flex__cell md-flex__cell--shrink">
        <a href="https://davidban77.gitlab.io/netapi" title="NetAPI" class="md-header-nav__button md-logo">
          
            <i class="md-icon"></i>
          
        </a>
      </div>
      <div class="md-flex__cell md-flex__cell--shrink">
        <label class="md-icon md-icon--menu md-header-nav__button" for="__drawer"></label>
      </div>
      <div class="md-flex__cell md-flex__cell--stretch">
        <div class="md-flex__ellipsis md-header-nav__title" data-md-component="title">
          
            <span class="md-header-nav__topic">
              NetAPI
            </span>
            <span class="md-header-nav__topic">
              
                Builders and Net Objects
              
            </span>
          
        </div>
      </div>
      <div class="md-flex__cell md-flex__cell--shrink">
        
          <label class="md-icon md-icon--search md-header-nav__button" for="__search"></label>
          
<div class="md-search" data-md-component="search" role="dialog">
  <label class="md-search__overlay" for="__search"></label>
  <div class="md-search__inner" role="search">
    <form class="md-search__form" name="search">
      <input type="text" class="md-search__input" name="query" placeholder="Search" autocapitalize="off" autocorrect="off" autocomplete="off" spellcheck="false" data-md-component="query" data-md-state="active">
      <label class="md-icon md-search__icon" for="__search"></label>
      <button type="reset" class="md-icon md-search__icon" data-md-component="reset" tabindex="-1">
        &#xE5CD;
      </button>
    </form>
    <div class="md-search__output">
      <div class="md-search__scrollwrap" data-md-scrollfix>
        <div class="md-search-result" data-md-component="result">
          <div class="md-search-result__meta">
            Type to start searching
          </div>
          <ol class="md-search-result__list"></ol>
        </div>
      </div>
    </div>
  </div>
</div>
        
      </div>
      
        <div class="md-flex__cell md-flex__cell--shrink">
          <div class="md-header-nav__source">
            


  

<a href="https://gitlab.com/the-networkers/netaudithor/netapi/" title="Go to repository" class="md-source" data-md-source="gitlab">
  
    <div class="md-source__icon">
      <svg viewBox="0 0 24 24" width="24" height="24">
        <use xlink:href="#__gitlab" width="24" height="24"></use>
      </svg>
    </div>
  
  <div class="md-source__repository">
    netaudithor/netapi
  </div>
</a>
          </div>
        </div>
      
    </div>
  </nav>
</header>
    
    <div class="md-container">
      
        
      
      
        

  

<nav class="md-tabs md-tabs--active" data-md-component="tabs">
  <div class="md-tabs__inner md-grid">
    <ul class="md-tabs__list">
      
        
  <li class="md-tabs__item">
    
      <a href="../.." class="md-tabs__link">
        Overview
      </a>
    
  </li>

      
        
  
  
    
    
  
  
    <li class="md-tabs__item">
      
        <a href="./" class="md-tabs__link md-tabs__link--active">
          API Reference
        </a>
      
    </li>
  

  

      
        
  
  
    <li class="md-tabs__item">
      
        <a href="../../about/changelog/" class="md-tabs__link">
          About
        </a>
      
    </li>
  

      
    </ul>
  </div>
</nav>
      
      <main class="md-main" role="main">
        <div class="md-main__inner md-grid" data-md-component="container">
          
            
              <div class="md-sidebar md-sidebar--primary" data-md-component="navigation">
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    <nav class="md-nav md-nav--primary" data-md-level="0">
  <label class="md-nav__title md-nav__title--site" for="__drawer">
    <a href="https://davidban77.gitlab.io/netapi" title="NetAPI" class="md-nav__button md-logo">
      
        <i class="md-icon"></i>
      
    </a>
    NetAPI
  </label>
  
    <div class="md-nav__source">
      


  

<a href="https://gitlab.com/the-networkers/netaudithor/netapi/" title="Go to repository" class="md-source" data-md-source="gitlab">
  
    <div class="md-source__icon">
      <svg viewBox="0 0 24 24" width="24" height="24">
        <use xlink:href="#__gitlab" width="24" height="24"></use>
      </svg>
    </div>
  
  <div class="md-source__repository">
    netaudithor/netapi
  </div>
</a>
    </div>
  
  <ul class="md-nav__list" data-md-scrollfix>
    
      
      
      


  <li class="md-nav__item">
    <a href="../.." title="Overview" class="md-nav__link">
      Overview
    </a>
  </li>

    
      
      
      

  


  <li class="md-nav__item md-nav__item--active md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-2" type="checkbox" id="nav-2" checked>
    
    <label class="md-nav__link" for="nav-2">
      API Reference
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="1">
      <label class="md-nav__title" for="nav-2">
        API Reference
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          

  


  <li class="md-nav__item md-nav__item--active md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-2-1" type="checkbox" id="nav-2-1" checked>
    
    <label class="md-nav__link" for="nav-2-1">
      Net Entities
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="2">
      <label class="md-nav__title" for="nav-2-1">
        Net Entities
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          

  


  <li class="md-nav__item md-nav__item--active">
    
    <input class="md-toggle md-nav__toggle" data-md-toggle="toc" type="checkbox" id="__toc">
    
    
      <label class="md-nav__link md-nav__link--active" for="__toc">
        Builders and Net Objects
      </label>
    
    <a href="./" title="Builders and Net Objects" class="md-nav__link md-nav__link--active">
      Builders and Net Objects
    </a>
    
      
<nav class="md-nav md-nav--secondary">
  
  
  
    <label class="md-nav__title" for="__toc">Table of contents</label>
    <ul class="md-nav__list" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#__init__" class="md-nav__link">
    __init__
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#interfacebuilder-objects" class="md-nav__link">
    InterfaceBuilder Objects
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#interfacebuilderget" class="md-nav__link">
    InterfaceBuilder.get()
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
          <li class="md-nav__item">
  <a href="#vlanbuilder-objects" class="md-nav__link">
    VlanBuilder Objects
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#vlanbuilderget" class="md-nav__link">
    VlanBuilder.get()
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
          <li class="md-nav__item">
  <a href="#vrrpbuilder-objects" class="md-nav__link">
    VrrpBuilder Objects
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#vrrpbuilderget" class="md-nav__link">
    VrrpBuilder.get()
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
          <li class="md-nav__item">
  <a href="#factsbuilder-objects" class="md-nav__link">
    FactsBuilder Objects
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#factsbuilderget" class="md-nav__link">
    FactsBuilder.get()
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
          <li class="md-nav__item">
  <a href="#routebuilder-objects" class="md-nav__link">
    RouteBuilder Objects
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#routebuilderget" class="md-nav__link">
    RouteBuilder.get()
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#facts" class="md-nav__link">
    facts
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#factsbase-objects" class="md-nav__link">
    FactsBase Objects
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#interface" class="md-nav__link">
    interface
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#interfacecounters-objects" class="md-nav__link">
    InterfaceCounters Objects
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#interfaceoptical-objects" class="md-nav__link">
    InterfaceOptical Objects
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#interfaceip-objects" class="md-nav__link">
    InterfaceIP Objects
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#interfacephysical-objects" class="md-nav__link">
    InterfacePhysical Objects
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#interfacebase-objects" class="md-nav__link">
    InterfaceBase Objects
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#interfacesbase-objects" class="md-nav__link">
    InterfacesBase Objects
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#route" class="md-nav__link">
    route
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#via-objects" class="md-nav__link">
    Via Objects
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#routebase-objects" class="md-nav__link">
    RouteBase Objects
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#routesbase-objects" class="md-nav__link">
    RoutesBase Objects
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#vlan" class="md-nav__link">
    vlan
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#vlanbase-objects" class="md-nav__link">
    VlanBase Objects
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#vlansbase-objects" class="md-nav__link">
    VlansBase Objects
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#vrrp" class="md-nav__link">
    vrrp
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#vrrpbase-objects" class="md-nav__link">
    VrrpBase Objects
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#vrrpsbase-objects" class="md-nav__link">
    VrrpsBase Objects
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
      
      
      
      
    </ul>
  
</nav>
    
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../api_net_eos_reference/" title="EOS" class="md-nav__link">
      EOS
    </a>
  </li>

        
      </ul>
    </nav>
  </li>

        
          
          
          


  <li class="md-nav__item md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-2-2" type="checkbox" id="nav-2-2">
    
    <label class="md-nav__link" for="nav-2-2">
      Connectors
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="2">
      <label class="md-nav__title" for="nav-2-2">
        Connectors
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          


  <li class="md-nav__item">
    <a href="../api_connector_reference/" title="Builders and Connector Objects" class="md-nav__link">
      Builders and Connector Objects
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../api_connector_eos_reference/" title="EOS" class="md-nav__link">
      EOS
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../api_connector_linux_reference/" title="Linux" class="md-nav__link">
      Linux
    </a>
  </li>

        
      </ul>
    </nav>
  </li>

        
          
          
          


  <li class="md-nav__item md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-2-3" type="checkbox" id="nav-2-3">
    
    <label class="md-nav__link" for="nav-2-3">
      Probes
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="2">
      <label class="md-nav__title" for="nav-2-3">
        Probes
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          


  <li class="md-nav__item">
    <a href="../api_probe_reference/" title="Builders and Probe Objects" class="md-nav__link">
      Builders and Probe Objects
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../api_probe_eos_reference/" title="EOS" class="md-nav__link">
      EOS
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../api_probe_ios_reference/" title="IOS" class="md-nav__link">
      IOS
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../api_probe_xe_reference/" title="IOS-XE" class="md-nav__link">
      IOS-XE
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../api_probe_xr_reference/" title="IOS-XR" class="md-nav__link">
      IOS-XR
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../api_probe_nxos_reference/" title="NXOS" class="md-nav__link">
      NXOS
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../api_probe_junos_reference/" title="JUNOS" class="md-nav__link">
      JUNOS
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../api_probe_linux_reference/" title="Linux" class="md-nav__link">
      Linux
    </a>
  </li>

        
      </ul>
    </nav>
  </li>

        
      </ul>
    </nav>
  </li>

    
      
      
      


  <li class="md-nav__item md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-3" type="checkbox" id="nav-3">
    
    <label class="md-nav__link" for="nav-3">
      About
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="1">
      <label class="md-nav__title" for="nav-3">
        About
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          


  <li class="md-nav__item">
    <a href="../../about/changelog/" title="Release Notes" class="md-nav__link">
      Release Notes
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../../about/license/" title="License" class="md-nav__link">
      License
    </a>
  </li>

        
      </ul>
    </nav>
  </li>

    
  </ul>
</nav>
                  </div>
                </div>
              </div>
            
            
              <div class="md-sidebar md-sidebar--secondary" data-md-component="toc">
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    
<nav class="md-nav md-nav--secondary">
  
  
  
    <label class="md-nav__title" for="__toc">Table of contents</label>
    <ul class="md-nav__list" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#__init__" class="md-nav__link">
    __init__
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#interfacebuilder-objects" class="md-nav__link">
    InterfaceBuilder Objects
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#interfacebuilderget" class="md-nav__link">
    InterfaceBuilder.get()
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
          <li class="md-nav__item">
  <a href="#vlanbuilder-objects" class="md-nav__link">
    VlanBuilder Objects
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#vlanbuilderget" class="md-nav__link">
    VlanBuilder.get()
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
          <li class="md-nav__item">
  <a href="#vrrpbuilder-objects" class="md-nav__link">
    VrrpBuilder Objects
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#vrrpbuilderget" class="md-nav__link">
    VrrpBuilder.get()
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
          <li class="md-nav__item">
  <a href="#factsbuilder-objects" class="md-nav__link">
    FactsBuilder Objects
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#factsbuilderget" class="md-nav__link">
    FactsBuilder.get()
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
          <li class="md-nav__item">
  <a href="#routebuilder-objects" class="md-nav__link">
    RouteBuilder Objects
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#routebuilderget" class="md-nav__link">
    RouteBuilder.get()
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#facts" class="md-nav__link">
    facts
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#factsbase-objects" class="md-nav__link">
    FactsBase Objects
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#interface" class="md-nav__link">
    interface
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#interfacecounters-objects" class="md-nav__link">
    InterfaceCounters Objects
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#interfaceoptical-objects" class="md-nav__link">
    InterfaceOptical Objects
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#interfaceip-objects" class="md-nav__link">
    InterfaceIP Objects
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#interfacephysical-objects" class="md-nav__link">
    InterfacePhysical Objects
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#interfacebase-objects" class="md-nav__link">
    InterfaceBase Objects
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#interfacesbase-objects" class="md-nav__link">
    InterfacesBase Objects
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#route" class="md-nav__link">
    route
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#via-objects" class="md-nav__link">
    Via Objects
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#routebase-objects" class="md-nav__link">
    RouteBase Objects
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#routesbase-objects" class="md-nav__link">
    RoutesBase Objects
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#vlan" class="md-nav__link">
    vlan
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#vlanbase-objects" class="md-nav__link">
    VlanBase Objects
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#vlansbase-objects" class="md-nav__link">
    VlansBase Objects
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#vrrp" class="md-nav__link">
    vrrp
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#vrrpbase-objects" class="md-nav__link">
    VrrpBase Objects
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#vrrpsbase-objects" class="md-nav__link">
    VrrpsBase Objects
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
      
      
      
      
    </ul>
  
</nav>
                  </div>
                </div>
              </div>
            
          
          <div class="md-content">
            <article class="md-content__inner md-typeset">
              
                
                  <a href="https://gitlab.com/the-networkers/netaudithor/netapi/edit/master/docs/api/api_net_reference.md" title="Edit this page" class="md-icon md-content__icon">&#xE3C9;</a>
                
                
                  <h1>Builders and Net Objects</h1>
                
                <h2 id="__init__"><code>__init__</code><a class="headerlink" href="#__init__" title="Permanent link">*</a></h2>
<p>Module that houses all network technology related builder objects, and performs the
respective calls the respective command and parser factories to get the registered
implementations.</p>
<p><strong>Example:</strong></p>
<div class="codehilite"><pre><span></span><span class="kn">from</span> <span class="nn">netapi.connector.pyeapier</span> <span class="kn">import</span> <span class="n">Device</span>
<span class="kn">from</span> <span class="nn">netapi.net</span> <span class="kn">import</span> <span class="n">FactsBuilder</span>

<span class="n">connector</span> <span class="o">=</span> <span class="n">Device</span><span class="p">(</span>
    <span class="n">host</span><span class="o">=</span><span class="s2">&quot;&lt;address&gt;&quot;</span><span class="p">,</span>
    <span class="n">username</span><span class="o">=</span><span class="s2">&quot;&lt;someuser&gt;&quot;</span><span class="p">,</span>
    <span class="n">password</span><span class="o">=</span><span class="s2">&quot;&lt;somepassword&gt;&quot;</span>
<span class="p">)</span>

<span class="n">facts</span> <span class="o">=</span> <span class="n">FactsBuilder</span><span class="p">()</span>

<span class="n">facts_dev</span> <span class="o">=</span> <span class="n">facts</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">connector</span><span class="o">=</span><span class="n">connector</span><span class="p">)</span>
<span class="k">print</span><span class="p">(</span><span class="n">facts_dev</span><span class="p">)</span>
<span class="c1"># Facts(hostname=&#39;lab01&#39;, os_version=&#39;4.21.5F&#39;, ...)</span>
</pre></div>


<h3 id="interfacebuilder-objects"><code>InterfaceBuilder</code> Objects<a class="headerlink" href="#interfacebuilder-objects" title="Permanent link">*</a></h3>
<p>Builder used to create Interface object(s).</p>
<p>Interface single object instatiation:</p>
<ul>
<li><code>entity</code>: True (default). Used to denote that only an Interface object is created</li>
<li><code>connector</code>: <code>Device</code> instance object</li>
<li><code>name</code>: string (required)</li>
</ul>
<p>Interfaces collections object instatiation:</p>
<ul>
<li><code>entity</code>: False. Used to denote a collection Interfaces object is created</li>
<li><code>connector</code>: <code>Device</code> instance object</li>
<li><code>interface_range</code>: (optional) Could be string '1-100' or by default is all
interfaces</li>
</ul>
<p><strong>Example:</strong></p>
<div class="codehilite"><pre><span></span><span class="n">interfaces</span> <span class="o">=</span> <span class="n">InterfaceBuilder</span><span class="p">()</span>
<span class="n">vl70</span> <span class="o">=</span> <span class="n">interfaces</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">connector</span><span class="p">,</span> <span class="n">name</span><span class="o">=</span><span class="mi">70</span><span class="p">)</span>
<span class="k">print</span><span class="p">(</span><span class="n">vl70</span><span class="p">)</span>
<span class="c1"># Interface(name=&#39;Vlan70&#39;, description=&#39;EXAMPLE-Interface&#39;, ...)</span>

<span class="n">intf_range</span> <span class="o">=</span> <span class="n">interfaces</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">connector</span><span class="p">,</span> <span class="n">entity</span><span class="o">=</span><span class="bp">False</span><span class="p">,</span> <span class="n">interface_range</span><span class="o">=</span><span class="s1">&#39;Eth1-3&#39;</span><span class="p">)</span>
<span class="k">print</span><span class="p">(</span><span class="n">intf_range</span><span class="p">)</span>
<span class="c1"># Interfaces(&#39;Ethernet1&#39;, &#39;Ethernet2&#39;, &#39;Ethernet3&#39;)</span>

<span class="k">print</span><span class="p">(</span><span class="n">intf_range</span><span class="p">[</span><span class="s1">&#39;Ethernet1&#39;</span><span class="p">])</span>
<span class="c1"># Interface(name=&#39;Ethernet1&#39;, name=&#39;EXAMPLE-Interface&#39;, ...)</span>
</pre></div>


<h4 id="interfacebuilderget"><code>InterfaceBuilder.get()</code><a class="headerlink" href="#interfacebuilderget" title="Permanent link">*</a></h4>
<div class="codehilite"><pre><span></span><span class="k">def</span> <span class="nf">get</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">connector</span><span class="p">,</span> <span class="n">entity</span><span class="o">=</span><span class="bp">True</span><span class="p">,</span> <span class="n">parameters</span><span class="o">=</span><span class="p">{},</span> <span class="n">interface_params</span><span class="p">)</span>
</pre></div>


<h3 id="vlanbuilder-objects"><code>VlanBuilder</code> Objects<a class="headerlink" href="#vlanbuilder-objects" title="Permanent link">*</a></h3>
<p>Builder used to create Vlan object(s).</p>
<p>Vlan single object instatiation:</p>
<ul>
<li><code>entity</code>: True (default). Used to denote that only an Vlan object is created</li>
<li><code>connector</code>: <code>Device</code> instance object</li>
<li><code>id</code>: integer (required)</li>
</ul>
<p>Vlans collections object instatiation:</p>
<ul>
<li><code>entity</code>: False. Used to denote a collection Vlans object is created</li>
<li><code>connector</code>: <code>Device</code> instance object</li>
<li><code>vlan_range</code>: (optional) Could be string '1-100' or a list [1, 100]</li>
</ul>
<p><strong>Example:</strong></p>
<div class="codehilite"><pre><span></span><span class="kn">from</span> <span class="nn">netapi.net</span> <span class="kn">import</span> <span class="n">VlanBuilder</span>

<span class="n">vlan</span> <span class="o">=</span> <span class="n">VlanBuilder</span><span class="p">()</span>
<span class="n">vl70</span> <span class="o">=</span> <span class="n">vlan</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">connector</span><span class="p">,</span> <span class="nb">id</span><span class="o">=</span><span class="mi">70</span><span class="p">)</span>
<span class="k">print</span><span class="p">(</span><span class="n">vl70</span><span class="p">)</span>
<span class="c1"># Vlan(id=70, interface=&#39;EXAMPLE-VLAN&#39;, ...)</span>

<span class="n">vlans</span> <span class="o">=</span> <span class="n">vlan</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">connector</span><span class="p">,</span> <span class="n">entity</span><span class="o">=</span><span class="bp">False</span><span class="p">,</span> <span class="n">vlan_range</span><span class="o">=</span><span class="s1">&#39;1-200&#39;</span><span class="p">)</span>
<span class="k">print</span><span class="p">(</span><span class="n">vlans</span><span class="p">)</span>
<span class="c1"># Vlans(1, 70, 177)</span>

<span class="k">print</span><span class="p">(</span><span class="n">vlans</span><span class="p">[</span><span class="mi">70</span><span class="p">])</span>
<span class="c1"># Vlan(id=70, name=&#39;EXAMPLE-VLAN&#39;, ...)</span>
</pre></div>


<h4 id="vlanbuilderget"><code>VlanBuilder.get()</code><a class="headerlink" href="#vlanbuilderget" title="Permanent link">*</a></h4>
<div class="codehilite"><pre><span></span><span class="k">def</span> <span class="nf">get</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">connector</span><span class="p">,</span> <span class="n">entity</span><span class="o">=</span><span class="bp">True</span><span class="p">,</span> <span class="n">parameters</span><span class="o">=</span><span class="p">{},</span> <span class="n">vlan_params</span><span class="p">)</span>
</pre></div>


<h3 id="vrrpbuilder-objects"><code>VrrpBuilder</code> Objects<a class="headerlink" href="#vrrpbuilder-objects" title="Permanent link">*</a></h3>
<p>Builder used to create Vrrp object(s).</p>
<p>Vrrp single object instatiation:</p>
<ul>
<li><code>entity</code>: True (default). Used to denote that only an Vrrp object is created</li>
<li><code>connector</code>: <code>Device</code> instance object</li>
<li><code>group_id</code>: integer (required)</li>
<li><code>interface</code>: string (optional)</li>
<li><code>instance</code>: string (optional)</li>
</ul>
<p>Vrrps collections object instatiation:</p>
<ul>
<li><code>entity</code>: False. Used to denote a collection Vrrps object is created</li>
<li><code>connector</code>: <code>Device</code> instance object</li>
<li><code>interface</code>: string (optional)</li>
<li><code>instance</code>: string (optional)</li>
</ul>
<p><strong>Example:</strong></p>
<div class="codehilite"><pre><span></span><span class="n">vrrp</span> <span class="o">=</span> <span class="n">VrrpBuilder</span><span class="p">()</span>
<span class="n">vr70</span> <span class="o">=</span> <span class="n">vrrp</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">connector</span><span class="p">,</span> <span class="n">group_id</span><span class="o">=</span><span class="mi">70</span><span class="p">)</span>
<span class="k">print</span><span class="p">(</span><span class="n">vr70</span><span class="p">)</span>
<span class="c1"># Vrrp(group_id=70, interface=&#39;Vlan177&#39;, ...)</span>

<span class="n">vrrp_vl177</span> <span class="o">=</span> <span class="n">vrrp</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">connector</span><span class="p">,</span> <span class="n">entity</span><span class="o">=</span><span class="bp">False</span><span class="p">,</span> <span class="n">interface</span><span class="o">=</span><span class="s1">&#39;Vlan177&#39;</span><span class="p">)</span>
<span class="k">print</span><span class="p">(</span><span class="n">vrrp_vl177</span><span class="p">)</span>
<span class="c1"># Vrrps((72, &#39;Vlan177&#39;), (71, &#39;Vlan177&#39;), (70, &#39;Vlan177&#39;))</span>

<span class="k">print</span><span class="p">(</span><span class="n">vrrp_vl177</span><span class="p">[(</span><span class="mi">70</span><span class="p">,</span> <span class="s1">&#39;Vlan177&#39;</span><span class="p">)])</span>
<span class="c1"># Vrrp(group_id=70, interface=&#39;Vlan177&#39;, ...)</span>
</pre></div>


<h4 id="vrrpbuilderget"><code>VrrpBuilder.get()</code><a class="headerlink" href="#vrrpbuilderget" title="Permanent link">*</a></h4>
<div class="codehilite"><pre><span></span><span class="k">def</span> <span class="nf">get</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">connector</span><span class="p">,</span> <span class="n">entity</span><span class="o">=</span><span class="bp">True</span><span class="p">,</span> <span class="n">parameters</span><span class="o">=</span><span class="p">{},</span> <span class="n">vrrp_params</span><span class="p">)</span>
</pre></div>


<h3 id="factsbuilder-objects"><code>FactsBuilder</code> Objects<a class="headerlink" href="#factsbuilder-objects" title="Permanent link">*</a></h3>
<p>Builder used to create Facts object.</p>
<p>Instatiation:</p>
<ul>
<li><code>connector</code>: <code>Device</code> instance object</li>
</ul>
<p><strong>Example:</strong></p>
<div class="codehilite"><pre><span></span><span class="n">facts</span> <span class="o">=</span> <span class="n">FactsBuilder</span><span class="p">()</span>
<span class="n">facts_dev</span> <span class="o">=</span> <span class="n">facts</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">connector</span><span class="o">=</span><span class="n">connector</span><span class="p">)</span>
<span class="k">print</span><span class="p">(</span><span class="n">facts_dev</span><span class="p">)</span>
<span class="c1"># Facts(hostname=&#39;lab01&#39;, os_version=&#39;4.21.5F&#39;, ...)</span>
</pre></div>


<h4 id="factsbuilderget"><code>FactsBuilder.get()</code><a class="headerlink" href="#factsbuilderget" title="Permanent link">*</a></h4>
<div class="codehilite"><pre><span></span><span class="k">def</span> <span class="nf">get</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">connector</span><span class="p">,</span> <span class="n">parameters</span><span class="o">=</span><span class="p">{},</span> <span class="n">facts_params</span><span class="p">)</span>
</pre></div>


<h3 id="routebuilder-objects"><code>RouteBuilder</code> Objects<a class="headerlink" href="#routebuilder-objects" title="Permanent link">*</a></h3>
<p>Builder used to create Route object(s).</p>
<p>Route single object instatiation:</p>
<ul>
<li><code>entity</code>: True (default). Used to denote that only an Route object is created</li>
<li><code>connector</code>: <code>Device</code> instance object</li>
<li><code>dest</code>: str (required)</li>
<li><code>instance</code>: string (optional)</li>
</ul>
<p>Routes collections object instatiation:</p>
<ul>
<li><code>entity</code>: False. Used to denote a collection Routes object is created</li>
<li><code>connector</code>: <code>Device</code> instance object</li>
<li><code>protocol</code>: string (optional)</li>
<li><code>instance</code>: string (optional)</li>
</ul>
<p><strong>Example:</strong></p>
<div class="codehilite"><pre><span></span><span class="n">route</span> <span class="o">=</span> <span class="n">RouteBuilder</span><span class="p">()</span>
<span class="n">r1</span> <span class="o">=</span> <span class="n">route</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">connector</span><span class="p">,</span> <span class="n">dest</span><span class="o">=</span><span class="s1">&#39;10.1.1.1&#39;</span><span class="p">)</span>
<span class="k">print</span><span class="p">(</span><span class="n">r1</span><span class="p">)</span>
<span class="c1"># Route(dest=&#39;10.1.1.1&#39;, instance=&#39;default&#39;, ...)</span>

<span class="n">routes</span> <span class="o">=</span> <span class="n">route</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">connector</span><span class="p">,</span> <span class="n">entity</span><span class="o">=</span><span class="bp">False</span><span class="p">,</span> <span class="n">por</span><span class="p">)</span>
<span class="k">print</span><span class="p">(</span><span class="n">routes</span><span class="p">)</span>
<span class="c1"># Routes((&#39;default&#39;, &#39;10.1.1.0/24&#39;),)</span>

<span class="k">print</span><span class="p">(</span><span class="n">routes</span><span class="p">[(</span><span class="s1">&#39;default&#39;</span><span class="p">,</span> <span class="s1">&#39;10.1.1.0/24&#39;</span><span class="p">)])</span>
<span class="c1"># Route(dest=&#39;10.1.1.1&#39;, instance=&#39;default&#39;, ...)</span>
</pre></div>


<h4 id="routebuilderget"><code>RouteBuilder.get()</code><a class="headerlink" href="#routebuilderget" title="Permanent link">*</a></h4>
<div class="codehilite"><pre><span></span><span class="k">def</span> <span class="nf">get</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">connector</span><span class="p">,</span> <span class="n">entity</span><span class="o">=</span><span class="bp">True</span><span class="p">,</span> <span class="n">parameters</span><span class="o">=</span><span class="p">{},</span> <span class="n">route_params</span><span class="p">)</span>
</pre></div>


<h2 id="facts"><code>facts</code><a class="headerlink" href="#facts" title="Permanent link">*</a></h2>
<p>Facts main dataclass object.</p>
<p>Contains all attributes and hints about the datatype (some attributes have the
attribute forced when is assigned).</p>
<h3 id="factsbase-objects"><code>FactsBase</code> Objects<a class="headerlink" href="#factsbase-objects" title="Permanent link">*</a></h3>
<p>Facts object definition.</p>
<p>Attributes:</p>
<ul>
<li><code>hostname</code>: (str) Hostname of the device</li>
<li><code>os_version</code>: (str) Network OS version of the system</li>
<li><code>model</code>: (str) Model/platform of the network device appliance</li>
<li><code>serial_number</code>: (str) Serial number of the device. Chassis for the modular ones</li>
<li><code>uptime</code>: (Duration) object which specifies the device uptime</li>
<li><code>up_since</code>: (DateTime) object which has the date since the device was UP</li>
<li><code>system_mac</code>: (EUI) MAC address object of the system/chassis</li>
<li><code>available_memory</code>: (Byte) object which specifies the system available memory</li>
<li><code>total_memory</code>: (Byte) object which specifies the system memory</li>
<li><code>os_arch</code>: (str) System OS architecture</li>
<li><code>hw_revision</code>: (str) Hardware revision of the device</li>
<li><code>interfaces</code>: (List) Interfaces available on the device</li>
<li><code>connector</code>: Device object used to perform the necessary connection.</li>
<li><code>metadata</code>: Metadata object which contains information about the current object.</li>
<li><code>get_cmd</code>: Command to retrieve route information out of the device</li>
</ul>
<h2 id="interface"><code>interface</code><a class="headerlink" href="#interface" title="Permanent link">*</a></h2>
<p>Interface main dataclass object.</p>
<p>Contains all attributes and hints about the datatype (some attributes have the
attribute forced when is assigned).</p>
<h3 id="interfacecounters-objects"><code>InterfaceCounters</code> Objects<a class="headerlink" href="#interfacecounters-objects" title="Permanent link">*</a></h3>
<p>Houses interface counters. All attributes are optional, but their default value is
a float -&gt; 0.0</p>
<p>Attributes:</p>
<ul>
<li><code>rx_bits_rate</code>: (Bit) Rx bps</li>
<li><code>tx_bits_rate</code>: (Bit) Tx bps</li>
<li><code>rx_pkts_rate</code>: (float) Rx pps</li>
<li><code>tx_pkts_rate</code>: (float) Tx pps</li>
<li><code>rx_unicast_pkts</code>: (float) Rx unicast pakets counter</li>
<li><code>tx_unicast_pkts</code>: (float) Tx unicast pakets counter</li>
<li><code>rx_multicast_pkts</code>: (float) Rx multicast pakets counter</li>
<li><code>tx_multicast_pkts</code>: (float) Tx multicast pakets counter</li>
<li><code>rx_broadcast_pkts</code>: (float) Rx broadcast pakets counter</li>
<li><code>tx_broadcast_pkts</code>: (float) Tx broadcast pakets counter</li>
<li><code>rx_bytes</code>: (Byte) Rx bytes counter</li>
<li><code>tx_bytes</code>: (Byte) Tx bytes counter</li>
<li><code>rx_discards</code>: (float) Rx discards counter</li>
<li><code>tx_discards</code>: (float) Tx discards counter</li>
<li><code>rx_errors_general</code>: (float) Rx main errors counter</li>
<li><code>tx_errors_general</code>: (float) Tx main errors counter</li>
<li><code>rx_errors_fcs</code>: (float) Rx FCS errors</li>
<li><code>rx_errors_crc</code>: (float) Rx CRC errors</li>
<li><code>rx_errors_runt</code>: (float) Rx runt frames errors</li>
<li><code>rx_errors_rx_pause</code>: (float) Rx pause errors</li>
<li><code>rx_errors_giant</code>: (float) Rx giant frames errors</li>
<li><code>rx_errors_symbol</code>: (float) Rx symbol errors</li>
<li><code>tx_errors_collisions</code>: (float) Tx collision errors</li>
<li><code>tx_errors_late_collisions</code>: (float) Tx late collision errors</li>
<li><code>tx_errors_deferred_transimissions</code>: (float) Tx deferred errors</li>
<li><code>tx_errors_tx_pause</code>: (float) Tx pause errors</li>
</ul>
<p>NOTE: For more information regarding the Byte/Bit objects:
https://bitmath.readthedocs.io/en/latest/instances.html</p>
<h3 id="interfaceoptical-objects"><code>InterfaceOptical</code> Objects<a class="headerlink" href="#interfaceoptical-objects" title="Permanent link">*</a></h3>
<p>Houses interface optical levels and status.</p>
<p>Attributes:</p>
<ul>
<li><code>tx</code>: (float) Tx dBm power of the optical interface</li>
<li><code>rx</code>: (float) Rx dBm power of the optical interface</li>
<li><code>status</code>: (str) Status flag of the optical interface based on the light levels</li>
<li><code>serial_number</code>: (str) Transceiver serial number</li>
<li><code>media_type</code>: (str) Transceiver media type</li>
</ul>
<h3 id="interfaceip-objects"><code>InterfaceIP</code> Objects<a class="headerlink" href="#interfaceip-objects" title="Permanent link">*</a></h3>
<p>Houses interface IP attributes.</p>
<p>Attributes:</p>
<ul>
<li><code>ipv4</code>: (IPNetwork) Primary IPv4 address of the interface.</li>
<li><code>ipv6</code>: (IPNetwork) Primary IPv6 address of the interface</li>
<li><code>secondary_ipv4</code>: (List[str]) List of ipv4 addresses on the interface</li>
<li><code>dhcp</code>: (bool) Flag to specify if address is DHCP learned</li>
</ul>
<h3 id="interfacephysical-objects"><code>InterfacePhysical</code> Objects<a class="headerlink" href="#interfacephysical-objects" title="Permanent link">*</a></h3>
<p>Houses interface physical attributes.</p>
<p>Attributes:</p>
<ul>
<li><code>mtu</code>: (Byte) Interface MTU value. NOTE: Is mainly interpreted as bytes</li>
<li><code>bandwidth</code>: (Bit) Interface descriptive bandwidth</li>
<li><code>duplex</code>: (str) Interface duplex mode. If applicable</li>
<li><code>mac</code>: (EUI) Interface EUI MAC address object</li>
</ul>
<h3 id="interfacebase-objects"><code>InterfaceBase</code> Objects<a class="headerlink" href="#interfacebase-objects" title="Permanent link">*</a></h3>
<p>Interface object definition.</p>
<p>Attributes:</p>
<ul>
<li><code>name</code>: (str) Interface name</li>
<li><code>description</code>: (str) Interface description</li>
<li><code>enabled</code>: (bool) specifying if the interface is enabled</li>
<li><code>status_up</code>: (bool) specifying if the interface is UP</li>
<li><code>status</code>: (str) Current interface status</li>
<li><code>last_status_change</code>: (DateTime) object specifying the last statys change</li>
<li><code>number_status_changes</code>: (int) Counter of interfaces status changes</li>
<li><code>forwarding_model</code>: (str) Specifies the forwarfing model of the device</li>
<li><code>instance</code>: (str) Is the VRF or routing instance of the interface object</li>
<li><code>members</code>: (List) Interfaces names that are memebers of a LAG</li>
<li><code>last_clear</code>: (DateTime) of last time counters were cleared</li>
<li><code>update_interval</code>: (float) Interface stats update interval</li>
<li><code>counters</code>: (InterfaceCounters) counters object attributes</li>
<li><code>physical</code>: (InterfacePhysical) physical object attributes</li>
<li><code>optical</code>: (InterfaceOptical) optical object attributes</li>
<li><code>addresses</code>: (InterfaceIP) addresses object attributes</li>
<li><code>interface_api</code>: API object which is dependant on the implementation used.</li>
<li><code>connector</code>: Device object used to perform the necessary connection.</li>
<li><code>metadata</code>: Metadata object which contains information about the current object.</li>
<li><code>get_cmd</code>: Command to retrieve interface information out of the device</li>
</ul>
<h3 id="interfacesbase-objects"><code>InterfacesBase</code> Objects<a class="headerlink" href="#interfacesbase-objects" title="Permanent link">*</a></h3>
<h2 id="route"><code>route</code><a class="headerlink" href="#route" title="Permanent link">*</a></h2>
<p>Route main dataclass object.</p>
<p>Contains all attributes and hints about the datatype (some attributes have the
attribute forced when is assigned).</p>
<h3 id="via-objects"><code>Via</code> Objects<a class="headerlink" href="#via-objects" title="Permanent link">*</a></h3>
<p>Via definition object.</p>
<p>Attributes:</p>
<ul>
<li><code>interface</code>: (str) Interface for the next hop of the route</li>
<li><code>next_hop</code>: (IPAddress) IP address of the next hop</li>
</ul>
<h3 id="routebase-objects"><code>RouteBase</code> Objects<a class="headerlink" href="#routebase-objects" title="Permanent link">*</a></h3>
<p>Route object definition.</p>
<p>Attributes:</p>
<ul>
<li><code>dest</code>: (str) IP Address/network to collect route information from the device</li>
<li><code>instance</code>: (str) Is the VRF or routing instance of the route object</li>
<li><code>network</code>: (IPNetwork) IP <code>dest</code>, destination, present on the device's route</li>
<li><code>protocol</code>: (str) Routing protocol</li>
<li><code>vias</code>: (List) Available <code>Via</code>s objects for the respective route</li>
<li><code>metric</code>: (int) Route metric (dependant on the routing protocol)</li>
<li><code>preference</code>: (int) Route preference (respect other routes and routing protocols)</li>
<li><code>active</code>: (bool) Flag which specifies if the route is currently active</li>
<li><code>inactive_reason</code>: (str) Description of the reason of an inactive route</li>
<li><code>age</code>: (Duration) object which tells the current age of the route. This is
available on some routes, not all implementations you can retrieve the <code>age</code>
attribute. You can look at the <code>metadata</code> object for creation and update time
of the object</li>
<li><code>tag</code>: (int) tag value assigned to the route</li>
<li><code>extra_attributes</code>: (Dict) Custom key and values depending on the implementation.</li>
<li><code>route_api</code>: API object which is dependant on the implementation used.</li>
<li><code>connector</code>: Device object used to perform the necessary connection.</li>
<li><code>metadata</code>: Metadata object which contains information about the current object.</li>
<li><code>get_cmd</code>: Command to retrieve route information out of the device</li>
</ul>
<h3 id="routesbase-objects"><code>RoutesBase</code> Objects<a class="headerlink" href="#routesbase-objects" title="Permanent link">*</a></h3>
<h2 id="vlan"><code>vlan</code><a class="headerlink" href="#vlan" title="Permanent link">*</a></h2>
<p>Vlan main dataclass object.</p>
<p>Contains all attributes and hints about the datatype (some attributes have the
attribute forced when is assigned).</p>
<h3 id="vlanbase-objects"><code>VlanBase</code> Objects<a class="headerlink" href="#vlanbase-objects" title="Permanent link">*</a></h3>
<p>Vlan object definition.</p>
<p>Attributes:</p>
<ul>
<li><code>id</code>: (int) ID of the vlan</li>
<li><code>name</code>: (str) Name of the vlan</li>
<li><code>status</code>: (str) Status of the vlan. The <code>status_conversion</code> is applied and also
sets the value of <code>status_up</code>.</li>
<li><code>status_up</code>: (bool) Flag indicating the current status of the vlan.</li>
<li><code>interfaces</code>: (List) contains interfaces configured under the vlan.</li>
<li><code>vlan_api</code>: API object which is dependant on the implementation used.</li>
<li><code>connector</code>: Device object used to perform the necessary connection.</li>
<li><code>metadata</code>: Metadata object which contains information about the current object.</li>
<li><code>get_cmd</code>: Command to retrieve route information out of the device</li>
<li><code>config_cmd</code>: Command to enable/disable object. Depending on the implementation it
can be automatically generated when issuing enable/disable methods. It can also be
generated using <code>generate_config_cmd()</code>.</li>
</ul>
<h3 id="vlansbase-objects"><code>VlansBase</code> Objects<a class="headerlink" href="#vlansbase-objects" title="Permanent link">*</a></h3>
<h2 id="vrrp"><code>vrrp</code><a class="headerlink" href="#vrrp" title="Permanent link">*</a></h2>
<p>Vrrp main dataclass object.</p>
<p>Contains all attributes and hints about the datatype (some attributes have the
attribute forced when is assigned).</p>
<h3 id="vrrpbase-objects"><code>VrrpBase</code> Objects<a class="headerlink" href="#vrrpbase-objects" title="Permanent link">*</a></h3>
<p>Vrrp object definition</p>
<p>Attributes:</p>
<ul>
<li><code>group_id</code>: (int) VRRP group ID</li>
<li><code>interface</code>: (str) Interface where the VRRP group is defined</li>
<li><code>description</code>: (str) VRRP description</li>
<li><code>version</code>: (int) VRRP version</li>
<li><code>status_up</code>: (bool) Flag of the vrrp status</li>
<li><code>status</code>: (str) Status of vrrp</li>
<li><code>instance</code>: (str) Instance/vrf of the vrrp object</li>
<li><code>virtual_ip</code>: (IPAddress) VRRP IP address</li>
<li><code>virtual_ip_secondary</code>: (List) Secondary virtual IP Addresses</li>
<li><code>virtual_mac</code>: (EUI) VRRP virtual MAC address</li>
<li><code>priority</code>: (int) VRRP priority value</li>
<li><code>master_ip</code>: (IPAddress) Current address of the master virtual router</li>
<li><code>master_priority</code>: (int) VRRP value of the master node priority</li>
<li><code>master_interval</code>: (int) Master advertisement interval in seconds (TBR)</li>
<li><code>mac_advertisement_interval</code>: (float) The time in seconds between sending neighbor
discovery or arp of the virtual mac address</li>
<li><code>preempt</code>: (bool) Flag is preemption is enabled</li>
<li><code>preempt_delay</code>: (float) Preemption delay time in seconds (TBR)</li>
<li><code>master_down_interval</code>: (float) The master down interval of the virtual router in
seconds</li>
<li><code>skew_time</code>: (float) The skew of the master down interval in seconds</li>
<li><code>tracked_objects</code>: (List[Dict]) tracked objects attributes</li>
<li><code>extra_attributes</code>: (Dict) Custom key and values depending on the implementation.</li>
<li><code>vrrp_api</code>: API object which is dependant on the implementation used.</li>
<li><code>connector</code>: Device object used to perform the necessary connection.</li>
<li><code>metadata</code>: Metadata object which contains information about the current object.</li>
<li><code>get_cmd</code>: Command to retrieve route information out of the device</li>
</ul>
<h3 id="vrrpsbase-objects"><code>VrrpsBase</code> Objects<a class="headerlink" href="#vrrpsbase-objects" title="Permanent link">*</a></h3>
                
                  
                
              
              
                


              
            </article>
          </div>
        </div>
      </main>
      
        
<footer class="md-footer">
  
    <div class="md-footer-nav">
      <nav class="md-footer-nav__inner md-grid">
        
          <a href="../.." title="Overview" class="md-flex md-footer-nav__link md-footer-nav__link--prev" rel="prev">
            <div class="md-flex__cell md-flex__cell--shrink">
              <i class="md-icon md-icon--arrow-back md-footer-nav__button"></i>
            </div>
            <div class="md-flex__cell md-flex__cell--stretch md-footer-nav__title">
              <span class="md-flex__ellipsis">
                <span class="md-footer-nav__direction">
                  Previous
                </span>
                Overview
              </span>
            </div>
          </a>
        
        
          <a href="../api_net_eos_reference/" title="EOS" class="md-flex md-footer-nav__link md-footer-nav__link--next" rel="next">
            <div class="md-flex__cell md-flex__cell--stretch md-footer-nav__title">
              <span class="md-flex__ellipsis">
                <span class="md-footer-nav__direction">
                  Next
                </span>
                EOS
              </span>
            </div>
            <div class="md-flex__cell md-flex__cell--shrink">
              <i class="md-icon md-icon--arrow-forward md-footer-nav__button"></i>
            </div>
          </a>
        
      </nav>
    </div>
  
  <div class="md-footer-meta md-typeset">
    <div class="md-footer-meta__inner md-grid">
      <div class="md-footer-copyright">
        
        powered by
        <a href="https://www.mkdocs.org">MkDocs</a>
        and
        <a href="https://squidfunk.github.io/mkdocs-material/">
          Material for MkDocs</a>
      </div>
      
  <div class="md-footer-social">
    <link rel="stylesheet" href="../../assets/fonts/font-awesome.css">
    
      <a href="https://github.com/davidban77" class="md-footer-social__link fa fa-github"></a>
    
      <a href="https://twitter.com/davidban77" class="md-footer-social__link fa fa-twitter"></a>
    
  </div>

    </div>
  </div>
</footer>
      
    </div>
    
      <script src="../../assets/javascripts/application.ac79c3b0.js"></script>
      
      <script>app.initialize({version:"1.0.4",url:{base:"../.."}})</script>
      
    
  </body>
</html>